<?php

// +------------------------------------------------------------------+
// | Package Information                                              |
// +------------------------------------------------------------------+

/**
 * @package     EuropaCart
 * @subpackage  JFramework
 * @copyright   Copyright 1999-Present Kryptronic, Inc.  All rights reserved.
 * @link        http://www.kryptronic.com
 * @license     GNU/GPL
*/

// +------------------------------------------------------------------+
// | Package                                                          |
// +------------------------------------------------------------------+

// +--
// | No direct access.
// +--

defined('_JEXEC') or die ('Restricted access');

// +--
// | Import the plugin controller.
// +--

jimport( 'joomla.plugin.plugin' );

// +------------------------------------------------------------------+
// | Class Definition                                                 |
// +------------------------------------------------------------------+

class plgSystemEuropaCart extends JPlugin {

// +------------------------------------------------------------------+
// | Function: Constructor                                            |
// +------------------------------------------------------------------+

function plgSystemEuropaCart (& $subject, $config) {

parent::__construct($subject, $config);

} // End of function.

// +------------------------------------------------------------------+
// | Function: onAfterInitialise                                      |
// +------------------------------------------------------------------+

function onAfterInitialise () {

// +--
// | This function loads a reference to the EuropaCartCommon class 
// | into a global variable for access by other components, modules and
// | plugins.
// +--

global $EuropaCart_ObjectCache;

$EuropaCart_ObjectCache['EuropaCartCommon'] =& new EuropaCartCommon();

} // End of function.

// +------------------------------------------------------------------+
// | End of Class                                                     |
// +------------------------------------------------------------------+

} // End of class.

// +------------------------------------------------------------------+
// | Class Definition                                                 |
// +------------------------------------------------------------------+

class EuropaCartCommon {

var $EuropaCartURL         = '';
var $EuropaCartPWD         = '';
var $EuropaCartSkinWidgets = array();

var $proxyurl   = '';
var $proxyuser  = '';
var $proxypass  = '';
var $proxyhttp  = 0;
var $proxyhttps = 0;

var $eol = "\r\n";

var $hce_md5_sec_key = 'UNDEFINED';
var $hce_md5_rand    = 'KRYPTRONIC';

// +------------------------------------------------------------------+
// | Function: Constructor                                            |
// +------------------------------------------------------------------+

function EuropaCartCommon () {

// +--
// | Load the database settings from the EuropaCart connector 
// | component and make them class variables.
// +--

$db  = JFactory::getDBO();

$sql = 'SELECT id,value FROM #__europacart';

$db->setQuery($sql);

$result = $db->loadAssocList();

foreach ($result as $num => $row) {

     if ($row['id'] == 'EuropaCart Full URL') {

          $this->EuropaCartURL = $row['value'];

     } elseif ($row['id'] == 'EuropaCart Connector Password') {

          $this->EuropaCartPWD = $row['value'];

     } // End of if statement.

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: sendXML                                                |
// +------------------------------------------------------------------+

function sendXML ($xmlrequest = array()) {

// +--
// | Function sends XML to a EuropaCart installation.
// +--

// +--
// | Add the EuropaCart Connector password to the XML request.
// +--

$xmlrequest['xml.0']['password.0'] = $this->EuropaCartPWD;

if (empty($xmlrequest['xml.0']['params.0'])) {$xmlrequest['xml.0']['params.0'] = array();}

$xmlrequest['xml.0']['params.0']   = @serialize($xmlrequest['xml.0']['params.0']);

// +--
// | Build the request.
// +--

$xmloutput  = '<!DOCTYPE xml SYSTEM "http://central.kryptronic.com/public/dtd/';
$xmloutput .= 'joomla_connector_req_v1.0.dtd">' . $this->eol;

$xmloutput .= $this->buildXML($xmlrequest);

// +--
// | Send the request.
// +--

$sid = ''; if (!(empty($_COOKIE['sid']))) {$sid = $_COOKIE['sid'];}

$result = $this->sendRequest(array('url'     => $this->EuropaCartURL,
                                   'type'    => 'POST',
                                   'mode'    => 'HTTP',
                                   'cookies' => 1,
                                   'data'    => array('app'     => 'core',
                                                      'ns'      => 'joomlaconnector',
                                                      'sid'     => $sid,
                                                      'request' => $xmloutput)));

// +--
// | Parse the response.
// +--

if (!(is_array($result))) {

     $result   = $this->parseXML($result);

     $response = @unserialize($result['xml.0']['response.0']);

     if (is_array($response)) {$result['xml.0']['response.0'] = $response;}

} // End of if statement.

// +--
// | Return the response.
// +--

return array('status'   => $result['xml.0']['status.0'],
             'response' => $result['xml.0']['response.0']);

} // End of function.

// +------------------------------------------------------------------+
// | Function: getSkinWidgets                                         |
// +------------------------------------------------------------------+

function getSkinWidgets () {

// +--
// | Function gets skin widgets from a EuropaCart installation.
// +--

// +--
// | Return if we've already ran this function.
// +--

if (!(empty($this->EuropaCartSkinWidgets))) {

     return array('status'   => 'OK',
                  'response' => $this->EuropaCartSkinWidgets);

} // End of if statement.

// +--
// | Build the XML request.
// +--

$xmlrequest  = array('xml.0' => array('app.0'       => 'core',
                                      'namespace.0' => 'joomlaskinwidgets'));

$result = $this->sendXML($xmlrequest);

// +--
// | Save the result.
// +--

$this->EuropaCartSkinWidgets = $result['response'];

// +--
// | Return.
// +--

return $result;

} // End of function.

// +------------------------------------------------------------------+
// | Function: parseXML                                               |
// +------------------------------------------------------------------+

function parseXML ($xmldata = '') {

// +--
// | This function creates an array of items from an XML string.  This
// | code is based very loosely on the parser given under the XML entry
// | in the PHP online manual by vladson at pc-labs dot info and 
// | modified by aerik at wikidweb dot com.  The original source code
// | was offered for free without license.
// +--

if (!(isset($xmldata))) {return array();}

// +--
// | Do the dirty work...
// +--

$xmlarray  = array();

// +--
// | Define the regular expressions for elements and attributes.
// +--

$regex_elements   = '/<(\w+)\s*([^\/>]*)\s*(?:\/>|>(.*?)<\/\s*\\1\s*>)/s';
$regex_attributes = '/(\w+)=(?:"|\')([^"\']*)(:?"|\')/';

// +--
// | Retrieve the element information.
// +--
 
preg_match_all($regex_elements, $xmldata, $elements);

foreach ($elements[1] as $ie => $ne) {

     $iec = '0';

     while (IsSet($xmlarray[$ne . '.' . $iec])) {$iec++;}

     if ($elements[1][$ie]) {

          $xmlarray[$ne . '.' . $iec] = '';

     } // End of if statement.

     // +--
     // | Retrieve the attribute information for the element.
     // +--

     if ($attributes = trim($elements[2][$ie])) {

          preg_match_all($regex_attributes, $attributes, $att);

          foreach ($att[1] as $ia => $na) {

               $iac = '0';

               while (IsSet($xmlarray[$ne . '.' . $iec . '.' . 'att'][$att[1][$ia] . '.' . $iac])) {$iac++;}

               $xmlarray[$ne . '.' . $iec . '.' . 'att'][$att[1][$ia] . '.' . $iac] = $this->XHTMLtranslate($att[2][$ia], 'DECODE');

          } // End of foreach statement.

     } // End of if statement.

     // +--
     // | Retrieve the text information for the element and process
     // | subelements separately.
     // +--

     $cdend = strpos($elements[3][$ie],'<');

     if ($cdend > '0') {

          $xmlarray[$ne . '.' . $iec] = substr($elements[3][$ie],0,$cdend -1);

     } // End of if statement.

     if (preg_match($regex_elements, $elements[3][$ie])) {

          $xmlarray[$ne . '.' . $iec] = $this->parseXML($elements[3][$ie]);

     } elseif (isset($elements[3][$ie])) {

          $xmlarray[$ne . '.' . $iec] = $this->XHTMLtranslate($elements[3][$ie], 'DECODE');

     } // End of if statement.

} // End of foreach statement.

unset($elements);

// +--
// | Return our array.
// +--

return $xmlarray;

} // End of function.

// +------------------------------------------------------------------+
// | Function: buildXML                                               |
// +------------------------------------------------------------------+

function buildXML ($xmldata = array()) {

// +--
// | This function builds an XML data structure from an array.
// +--

if ((!(isset($xmldata))) || (!(is_array($xmldata)))) {return '';}

// +--
// | Start with a blank XML string.
// +--

$xmlstring = '';

// +--
// | Build the XML structure.
// +--

foreach ($xmldata as $key => $value) {

     // +--
     // | Skip attributes array keys.
     // +--

     if (!(preg_match('/^(.*?)\.(.*?)\.att$/',$key))) {

          $key1 = preg_replace('/^(.*?)\.(.*?)$/','\\1',$key);
          $key2 = preg_replace('/^(.*?)\.(.*?)$/','\\1',$key);

          // +--
          // | Handle keys where attributes exist.
          // +--

          if (array_key_exists($key . '.att',$xmldata)) {

               $att = $xmldata[$key . '.att'];

               foreach ($att as $attname => $attvalue) {

                    $attname  = preg_replace('/^(.*?)\.(.*?)$/','\\1',$attname);
                    $key1    .= ' ' . $attname . '="';
                    $key1    .= $this->XHTMLtranslate($attvalue, 'ENCODE') . '"';

               } // End of foreach statement.

          } // End of if statement.

          // +--
          // | Build the XML data structure with the calculated
          // | key.
          // +--

          if (is_array($value)) {

               $xmlstring .= '<'  . $key1 . '>' . $this->eol;
               $xmlstring .= $this->buildXML($value);
               $xmlstring .= '</' . $key2 . '>' . $this->eol;

          } else {

               $xmlstring .= '<'  . $key1 . '>';
               $xmlstring .= $this->XHTMLtranslate($value, 'ENCODE');
               $xmlstring .= '</' . $key2 . '>' . $this->eol;

          } // End of if statement.

     } // End of if statement.

} // End of foreach statement.

// +--
// | Return our string.
// +--

return $xmlstring;

} // End of function.

// +------------------------------------------------------------------+
// | Function: XHTMLtranslate                                         |
// +------------------------------------------------------------------+

function XHTMLtranslate ($string = '', $encdec = 'ENCODE') {

// +--
// | This function encodes XHTML strings replacing ASCII entities
// | with XHTML entities.  It accepts two paramters: 
// |
// | string => The string to encode or decode
// |
// | encdec => A string 'ENCODE' or 'DECODE' to let this function
// |           know which action to perform.
// +--

global $trans_encode;
global $trans_decode;

if ((!($trans_encode)) || (!($trans_decode))) {

      $trans = get_html_translation_table(HTML_ENTITIES, ENT_QUOTES);

      foreach ($trans as $key => $value) {

           $trans[$key]    = '&#' . ord($key) . ';';

     } // End of foreach statement.

     $trans[chr(38)] = '&';
     $trans['$']     = '&#36;';

     $trans_encode = $trans;
     $trans_decode = array_flip($trans);

} // End of if statement.

if (($string) && ($encdec == 'ENCODE')) {

     $find = '&(?![A-Za-z]{0,4}\w{2,3};|#[0-9]{2,3};)';

     $string = preg_replace('/' . $find . '/','&#38;',strtr($string,$trans_encode));

} elseif (($string) && ($encdec == 'DECODE')) {

     $string = preg_replace('/&#38;/','&',strtr($string,$trans_decode));

} // End of if statement.

// +--
// | Return the string.
// +--

return $string;

} // End of function.

// +------------------------------------------------------------------+
// | Function: sendRequest                                            |
// +------------------------------------------------------------------+

function sendRequest ($input = array()) {

// +--
// | This routine makes a connection via cURL to a remote URL.
// +--

// +--
// | Set our default function values.
// +--

$url     = (isset($input['url'])     ? $input['url']     : '');
$type    = (isset($input['type'])    ? $input['type']    : 'POST');
$mode    = (isset($input['mode'])    ? $input['mode']    : 'HTTP');
$data    = (isset($input['data'])    ? $input['data']    : array());
$referer = (isset($input['referer']) ? $input['referer'] : '');
$uagent  = (isset($input['uagent'])  ? $input['uagent']  : '');
$headers = (isset($input['headers']) ? $input['headers'] : array());
$cookies = (isset($input['cookies']) ? $input['cookies'] : 0);

unset($input);

// +--
// | Return a error if our $url, $type or $mode are blank.
// +--

if ((!($url)) || (!($type)) || (!($mode))) {

     return array('status'   => 'ERROR',
                  'response' => 'A request was made to connect to a remote URL, however 
                                 the request was incomplete.');

} // End of if statement.

// +--
// | Build out our query string.
// +--

$query_string = '';

if (is_array($data)) {

     foreach ($data as $name => $value) {

          $query_string .= $name . '=' . urlencode($value) . '&';

     } // End of foreach statement.

     if ($query_string) {

          $query_string = substr($query_string, 0, -1);

     } // End of if statement.

} // End of if statement.

// +--
// | Set our URL parameter.  If we have a GET request, we build
// | our $query_string onto our URL.
// +--

if (($type == 'GET') && ($query_string)) {

     $url .= '?' . $query_string;

} // End of if statement.

// +--
// | Initiate a cURL handle.
// +--

$ch = curl_init();

// +--
// | Set our URL parameter.
// +--

curl_setopt($ch, CURLOPT_URL, $url);

// +--
// | Set our POST options if this is a POST request.  We set the 
// | post fields to the $query_string if $data was an array.
// | Otherwise we set our post fields to the $data variable.
// +--

if (($type == 'POST') && ($query_string)) {

     curl_setopt($ch, CURLOPT_POST, 1);
     curl_setopt($ch, CURLOPT_POSTFIELDS, $query_string);

} elseif (($type == 'POST') && ($data)) {

     curl_setopt($ch, CURLOPT_POST, 1);
     curl_setopt($ch, CURLOPT_POSTFIELDS, $data);

} // End of if statement.

unset($data);

// +--
// | Define our referer (sp. referrer).
// +--

if (empty($referer)) {

     $referer = $url;

} // End of if statement.

// +--
// | Define custom headers.
// +--

if (!(empty($headers))) {

     curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

} // End of if statement.

// +--
// | Send cookies if necessary.
// +--

if (!(empty($cookies))) {

     curl_setopt($ch, CURLOPT_HEADER, 1);

     $session_id   = @session_id();
     $session_name = @session_name();

     if ((!(empty($session_name))) && (!(empty($session_id))) && (empty($_COOKIE[$session_name]))) {

          $_COOKIE[$session_name] = $session_id;

     } // End of if statement.

     if (!(empty($_COOKIE))) {

          $cookiestring = '';

          foreach ($_COOKIE as $name => $value) {

               $cookiestring .= $name . '=' . $value . '; ';

          } // End of foreach statement.

          $cookiestring = preg_replace('/\; $/','',$cookiestring);

          if (!(empty($cookiestring))) {

               curl_setopt($ch, CURLOPT_COOKIE, $cookiestring);

          } // End of if statement.

     } // End of if statement.

} // End of if statement.

// +--
// | Define our user agent.
// +--

if (empty($uagent)) {

     $user_agent = 'Kryptronic EuropaCart 7';

} // End of if statement.

// +--
// | Set other cURL options.
// +--

curl_setopt($ch, CURLOPT_TIMEOUT, 25);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_REFERER, $referer);
curl_setopt($ch, CURLOPT_USERAGENT, $uagent);

// +--
// | If we use a proxy, we configure it here.
// +--

if ($this->proxyurl) {

     if (($mode == 'HTTP') && ($this->proxyhttp)) {

          curl_setopt($ch, CURLOPT_HTTPPROXYTUNNEL, 1);
          curl_setopt($ch, CURLOPT_PROXY, $this->proxyurl);

          if (($this->proxyuser) && ($this->proxypass)) {

               $user_pass = $this->proxyuser . ':' . $this->proxypass;

               curl_setopt($ch, CURLOPT_PROXYUSERPWD, $user_pass);

          } // End of if statement.

     } // End of if statement.

     if (($mode == 'HTTPS') && ($this->proxyhttps)) {

          curl_setopt($ch, CURLOPT_HTTPPROXYTUNNEL, 1);
          curl_setopt($ch, CURLOPT_PROXY, $this->proxyurl);

          if (($this->proxyuser) && ($this->proxypass)) {

               $user_pass = $this->proxyuser . ':' . $this->proxypass;

               curl_setopt($ch, CURLOPT_PROXYUSERPWD, $user_pass);

           } // End of if statement.

      } // End of if statement.

} // End of if statement.

// +--
// | Set verifyPeer and verifyHost to false to avoid Peer and Host
// | verification errors (especially on Windows).
// +--

curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);

// +--
// | Execute our cURL request.
// +--

$result = curl_exec($ch);

// +--
// | If our request was successful, we return our result.
// | Otherwise we return an error.
// +--

if (!($result)) {

     $message = curl_error($ch);

     if (!($message)) {

          $message = "A request was made to connect to a remote URL, 
                      however there was a general cURL error while 
                      processing the request.";

     } // End of if statement.

     return array('status'   => 'ERROR',
                  'response' => $message);

} // End of if statement.

// +--
// | Parse the cookies out of the result if necessary.
// +--

if (!(empty($cookies))) {

     $result = $this->parse_response($result);

     $cookiestring          = '';
     $cookies_to_set        = array();

     if (!(empty($result['header']['Set-Cookie']))) {$cookiestring = $result['header']['Set-Cookie'];}

     if (!(empty($cookiestring))) {

          $cookiesset = explode("\n", $cookiestring);

          foreach ($cookiesset as $cookienum => $cookievalue) {

               $cookievalue = preg_replace('/\; /',';',$cookievalue);

               $cookievalue = explode(';',$cookievalue);

               $xcookie = array();

               foreach ($cookievalue as $cnum => $cvalue) {

                    if (preg_match('/=/',$cvalue)) {

                         list($name,$value) = explode('=', $cvalue, 2);

                         if (($name == 'expires') || ($name == 'path') || ($name == 'domain')) {

                              $xcookie[$name] = $value;

                         } else {

                              $xcookie['name']  = $name;
                              $xcookie['value'] = $value;

                         } // End of if statement.

                    } else {

                         $xcookie[$cvalue] = 1;

                    } // End of if statement.

               } // End of foreach statement.

               if (!(empty($xcookie['name']))) {

                    if (empty($xcookie['value']))      {$xcookie['value']    = '';}
                    if (empty($xcookie['expires']))    {$xcookie['expires']  = 0;}
                    if (empty($xcookie['path']))       {$xcookie['path']     = '/';}
                    if (empty($xcookie['domain']))     {$xcookie['domain']   = '';}
                    if (!(empty($xcookie['expires']))) {$xcookie['expires']  = @strtotime($xcookie['expires']);}

                    $cookies_to_set[] = $xcookie;

               } // End of if statement.

          } // End of foreach statement.

     } // End of if statement.

     if (!(empty($cookies_to_set))) {

          foreach ($cookies_to_set as $num => $xcookie) {

               setcookie($xcookie['name'], $xcookie['value'], $xcookie['expires'], $xcookie['path'], $xcookie['domain']);

               $_COOKIE[$xcookie['name']] = $xcookie['value'];

               if ((!(empty($xcookie['expires']))) && ($xcookie['expires'] < @time())) {unset($_COOKIE[$xcookie['name']]);}

          } // End of foreach statement.

     } // End of if statement.

     $result = $result['body'];

} // End of if statement.

// +--
// | Return the result.
// +--

return $result;

} // End of function.

// +------------------------------------------------------------------+
// | Function: parse_response                                         |
// +------------------------------------------------------------------+

function parse_response ($response = '') {

// +--
// | This function parses header information from a curl response.
// +--

// +--
// | Split response into header and body sections.
// +--

list($response_headers, $response_body) = explode("\r\n\r\n", $response, 2);

$response_header_lines = explode("\r\n", $response_headers);

// +--
// | First line of headers is the HTTP response code.
// +--

$http_response_line = array_shift($response_header_lines);

if (preg_match('/^HTTP\/[0-9]\.[0-9] ([0-9]{3})/',$http_response_line, $matches)) {

     $response_code = $matches[1];

} // End of if statement.

// +--
// | Put the rest of the headers in an array.
// +--

$response_header_array = array();

foreach ($response_header_lines as $header_line) {

     list($header,$value) = explode(': ', $header_line, 2);

     if (empty($response_header_array[$header])) {$response_header_array[$header] = '';}

     $response_header_array[$header] .= $value . "\n";

} // End of foreach statement.

// +--
// | Return the result.
// +--

return array('code'   => $response_code,
             'header' => $response_header_array,
             'body'   => $response_body);

} // End of function.

// +------------------------------------------------------------------+
// | Function: xnew_key                                               |
// +------------------------------------------------------------------+

function xnew_key ($key = null, $rand = null) {

// +--
// | THIS IS A PRIVATE FUNCTION.
// +--

if (!(isset($key)))  {$key  = $this->hce_md5_sec_key;}
if (!(isset($rand))) {$rand = $this->hce_md5_rand;}

// +--
// | Create a digest.
// +--

$digest = md5($key . $rand);
    
// +--
// | Convert the digest to a binary representation and
// | create a block.
// +--
    
$digest = pack("H*", $digest);
    
$block  = unpack('C*', $digest);
    
// +--
// | Return the block.
// +--

return $block;

} // End of function.

// +------------------------------------------------------------------+
// | Function: xpackarray                                             |
// +------------------------------------------------------------------+

function xpackarray ($parray = null) {

// +--
// | THIS IS A PRIVATE FUNCTION.
// +--

// +--
// | This assumes that array is ones based.  We do this 
// | because the php unpack uses a ones based array.
// +--

if (!(isset($parray[0]))) {$parray[0] = 0;}

$out = "";

$len = count($parray);

for ($i = 1; $i < $len; $i++) {

     $out .= chr($parray[$i]);

} // End of for statement.
    
// +--
// | Return out variable.
// +--

return $out;

} // End of function.

// +------------------------------------------------------------------+
// | End of Class                                                     |
// +------------------------------------------------------------------+

} // End of class.

// +------------------------------------------------------------------+
// | End Of File                                                      |
// +------------------------------------------------------------------+

?>